OGRE: Ogre::NumericAnimationTrack Class Reference - OGRE Documentation

# Ogre::NumericAnimationTrack Class Reference

Specialised AnimationTrack for dealing with generic animable values. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::NumericAnimationTrack:

[legend]

List of all members.

## Public Member Functions
| NumericAnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
| NumericAnimationTrack (Animation *parent, unsigned short handle, AnimableValuePtr &target)
| Constructor, associates with an AnimableValue.
virtual NumericKeyFrame * | createNumericKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const
  | Gets a KeyFrame object which contains the interpolated transforms at the time index specified. Remarks: The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'. Parameters:
  | timeIndex | The time (in relation to the whole animation sequence)
  | kf | Keyframe object to store results
virtual void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)
  | Applies an animation track to the designated target. Parameters:
  | timeIndex | The time position in the animation to apply.
  | weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  | scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.
void | applyToAnimable (const AnimableValuePtr &anim, const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)
| Applies an animation track to a given animable value.
virtual const AnimableValuePtr & | getAssociatedAnimable (void) const
| Returns a pointer to the associated animable object (if any).
virtual void | setAssociatedAnimable (const AnimableValuePtr &val)
| Sets the associated animable object which will be automatically affected by calls to 'apply'.
NumericKeyFrame * | getNumericKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
NumericAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only).
unsigned short | getHandle (void) const
| Get the handle associated with this track.
virtual unsigned short | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
virtual KeyFrame * | getKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual Real | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.
virtual void | _keyFrameDataChanged (void) const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
virtual bool | hasNonZeroKeyFrames (void) const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
virtual void | optimise (void)
| Optimise the current track by removing any duplicate keyframes.
virtual void | _collectKeyFrameTimes (std::vector< Real > &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format.
virtual void | _buildKeyFrameIndexMap (const std::vector< Real > &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.
virtual void | setListener (Listener *l)
| Set a listener for this track.
Animation * | getParent () const
| Returns the parent Animation object for this track.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
typedef std::vector< KeyFrame * > | KeyFrameList
typedef std::vector< ushort > | KeyFrameIndexMap
| Map used to translate global keyframe time lower bound index to local lower bound index.
## Protected Member Functions
KeyFrame * | createKeyFrameImpl (Real time)
| Create a keyframe implementation - must be overridden.
virtual void | populateClone (AnimationTrack *clone) const
| Internal method for clone implementation.
## Protected Attributes
AnimableValuePtr | mTargetAnim
| Target to animate.
KeyFrameList | mKeyFrames
Animation * | mParent
unsigned short | mHandle
Listener * | mListener
KeyFrameIndexMap | mKeyFrameIndexMap

## Detailed Description

Specialised AnimationTrack for dealing with generic animable values.

Definition at line 256 of file OgreAnimationTrack.h.

## Member Typedef Documentation

typedef std::vector<KeyFrame*> Ogre::AnimationTrack::KeyFrameList`[protected, inherited]`

Definition at line 234 of file OgreAnimationTrack.h.

typedef std::vector<ushort> Ogre::AnimationTrack::KeyFrameIndexMap`[protected, inherited]`

Map used to translate global keyframe time lower bound index to local lower bound index.

Definition at line 241 of file OgreAnimationTrack.h.

## Constructor & Destructor Documentation

Ogre::NumericAnimationTrack::NumericAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle |
| ) |  |  |

Constructor.

Ogre::NumericAnimationTrack::NumericAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | AnimableValuePtr & | target |
| ) |  |  |

Constructor, associates with an AnimableValue.

## Member Function Documentation

virtual NumericKeyFrame* Ogre::NumericAnimationTrack::createNumericKeyFrame | ( | Real | timePos | ) | `[virtual]`

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks:
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters:

  | timePos | The time from which this KeyFrame will apply.

virtual void Ogre::NumericAnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf |
| ) |  |  | const`[virtual]`

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

Remarks:
  The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters:

  | timeIndex | The time (in relation to the whole animation sequence)
  | kf | Keyframe object to store results

Implements Ogre::AnimationTrack.

virtual void Ogre::NumericAnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = `1.0`,
|  | Real | scale = `1.0f` |
| ) |  |  | `[virtual]`

Applies an animation track to the designated target.

Parameters:

  | timeIndex | The time position in the animation to apply.
  | weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  | scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::AnimationTrack.

void Ogre::NumericAnimationTrack::applyToAnimable | ( | const AnimableValuePtr & | anim,
|  | const TimeIndex & | timeIndex,
|  | Real | weight = `1.0`,
|  | Real | scale = `1.0f` |
| ) |  |  |

Applies an animation track to a given animable value.

Parameters:

  | anim | The AnimableValue to which to apply the animation
  | timeIndex | The time position in the animation to apply.
  | weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  | scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

virtual const AnimableValuePtr& Ogre::NumericAnimationTrack::getAssociatedAnimable | ( | void |  | ) | const`[virtual]`

Returns a pointer to the associated animable object (if any).

virtual void Ogre::NumericAnimationTrack::setAssociatedAnimable | ( | const AnimableValuePtr & | val | ) | `[virtual]`

Sets the associated animable object which will be automatically affected by calls to 'apply'.

NumericKeyFrame* Ogre::NumericAnimationTrack::getNumericKeyFrame | ( | unsigned short | index | ) | const

Returns the KeyFrame at the specified index.

NumericAnimationTrack* Ogre::NumericAnimationTrack::_clone | ( | Animation * | newParent | ) | const

Clone this track (internal use only).

KeyFrame* Ogre::NumericAnimationTrack::createKeyFrameImpl | ( | Real | time | ) | `[protected, virtual]`

Create a keyframe implementation - must be overridden.

Implements Ogre::AnimationTrack.

unsigned short Ogre::AnimationTrack::getHandle | ( | void |  | ) | const`[inherited]`

Get the handle associated with this track.

Definition at line 140 of file OgreAnimationTrack.h.

virtual unsigned short Ogre::AnimationTrack::getNumKeyFrames | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of keyframes in this animation.

virtual KeyFrame* Ogre::AnimationTrack::getKeyFrame | ( | unsigned short | index | ) | const`[virtual, inherited]`

Returns the KeyFrame at the specified index.

virtual Real Ogre::AnimationTrack::getKeyFramesAtTime | ( | const TimeIndex & | timeIndex,
|  | KeyFrame ** | keyFrame1,
|  | KeyFrame ** | keyFrame2,
|  | unsigned short * | firstKeyIndex = `0` |
| ) |  |  | const`[virtual, inherited]`

Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.

Remarks:
  At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after.

  This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc.

Parameters:

  | timeIndex | The time index.
  | keyFrame1 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just before or at this time index.
  | keyFrame2 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just after this time index.
  | firstKeyIndex | Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe in case the caller needs it.

Returns:
  Parametric value indicating how far along the gap between the 2 keyframes the timeIndex value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 <= returnValue < 1.0 .

virtual KeyFrame* Ogre::AnimationTrack::createKeyFrame | ( | Real | timePos | ) | `[virtual, inherited]`

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks:
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters:

  | timePos | The time from which this KeyFrame will apply.

virtual void Ogre::AnimationTrack::removeKeyFrame | ( | unsigned short | index | ) | `[virtual, inherited]`

Removes a KeyFrame by it's index.

virtual void Ogre::AnimationTrack::removeAllKeyFrames | ( | void |  | ) | `[virtual, inherited]`

Removes all the KeyFrames from this track.

virtual void Ogre::AnimationTrack::_keyFrameDataChanged | ( | void |  | ) | const`[virtual, inherited]`

Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.

Reimplemented in Ogre::NodeAnimationTrack.

Definition at line 210 of file OgreAnimationTrack.h.

virtual bool Ogre::AnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const`[virtual, inherited]`

Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.

Reimplemented in Ogre::NodeAnimationTrack, and Ogre::VertexAnimationTrack.

Definition at line 216 of file OgreAnimationTrack.h.

virtual void Ogre::AnimationTrack::optimise | ( | void |  | ) | `[virtual, inherited]`

Optimise the current track by removing any duplicate keyframes.

Reimplemented in Ogre::NodeAnimationTrack, and Ogre::VertexAnimationTrack.

Definition at line 219 of file OgreAnimationTrack.h.

virtual void Ogre::AnimationTrack::_collectKeyFrameTimes | ( | std::vector< Real > & | keyFrameTimes | ) | `[virtual, inherited]`

Internal method to collect keyframe times, in unique, ordered format.

virtual void Ogre::AnimationTrack::_buildKeyFrameIndexMap | ( | const std::vector< Real > & | keyFrameTimes | ) | `[virtual, inherited]`

Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.

virtual void Ogre::AnimationTrack::setListener | ( | Listener * | l | ) | `[virtual, inherited]`

Set a listener for this track.

Definition at line 229 of file OgreAnimationTrack.h.

Animation* Ogre::AnimationTrack::getParent | ( |  | ) | const`[inherited]`

Returns the parent Animation object for this track.

Definition at line 232 of file OgreAnimationTrack.h.

virtual void Ogre::AnimationTrack::populateClone | ( | AnimationTrack * | clone | ) | const`[protected, virtual, inherited]`

Internal method for clone implementation.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

AnimableValuePtr Ogre::NumericAnimationTrack::mTargetAnim`[protected]`

Target to animate.

Definition at line 307 of file OgreAnimationTrack.h.

KeyFrameList Ogre::AnimationTrack::mKeyFrames`[protected, inherited]`

Definition at line 235 of file OgreAnimationTrack.h.

Animation* Ogre::AnimationTrack::mParent`[protected, inherited]`

Definition at line 236 of file OgreAnimationTrack.h.

unsigned short Ogre::AnimationTrack::mHandle`[protected, inherited]`

Definition at line 237 of file OgreAnimationTrack.h.

Listener* Ogre::AnimationTrack::mListener`[protected, inherited]`

Definition at line 238 of file OgreAnimationTrack.h.

KeyFrameIndexMap Ogre::AnimationTrack::mKeyFrameIndexMap`[protected, inherited]`

Definition at line 242 of file OgreAnimationTrack.h.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:32:44 2009